SystemOrganization addCategory: #'Phantom-Core'!

ObjectAsMethodWrapper subclass: #PhMethodWrapper
	instanceVariableNames: 'needCleanUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

PhMethodWrapper subclass: #PhMembraneMethodWrapper
	instanceVariableNames: 'membranes'
	classVariableNames: 'ProcessMembraneStack ProcessObjectDeployedMembraneStack ProcessObjectStack'
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 02:23'!
currentObjectDeployedMembraneStack
	^ self processObjectDeployedMembraneStack at: (Processor activeProcess) ifAbsent: [#()]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:13'!
currentProcessMembraneStack
	^ self processMembraneStack at: (Processor activeProcess) ifAbsent: [#()]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:11'!
currentProcessObjectStack
	^ self processObjectStack at: (Processor activeProcess) ifAbsent: [#()]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 4/28/2011 20:11'!
on: aClass selector: aSelector with: aMembraneArray
	^ (super on: aClass selector: aSelector)
		membranes: aMembraneArray;
		yourself! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:08'!
popObjectOnCurrentProcess
	self processObjectStack at: (Processor activeProcess) 
		ifPresent: [:col | col ifNotEmpty: [:collection | collection removeLast] ]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:13'!
processMembraneStack
	^ ProcessMembraneStack ifNil: [ProcessMembraneStack := WeakKeyToCollectionDictionary new]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:18'!
processObjectDeployedMembraneStack
	^ ProcessObjectDeployedMembraneStack ifNil: [ProcessObjectDeployedMembraneStack := WeakKeyToCollectionDictionary new]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:03'!
processObjectStack
	^ ProcessObjectStack ifNil: [ProcessObjectStack := WeakKeyToCollectionDictionary new]! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:13'!
setActiveMembranes: aMembraneArray
	self processMembraneStack at: (Processor activeProcess) put: aMembraneArray! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:20'!
setObjectDeployedActiveMembranes: aMembraneArray
	self processObjectDeployedMembraneStack at: (Processor activeProcess) put: aMembraneArray! !

!PhMembraneMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:06'!
stackObjectOnCurrentProcess: anObject
	self processObjectStack at: (Processor activeProcess) 
		ifPresent: [:col | col add: anObject]
		ifAbsent: [self processObjectStack at: (Processor activeProcess) put: (OrderedCollection with: anObject)]! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:24'!
activeObjectDeployedMembraneSet
	| mbrSet callStack |
	callStack := PhMembraneMethodWrapper currentProcessObjectStack.
	mbrSet := Set new.
	callStack do: [:rc |
		PhAspectWeaver objectMembranes at: rc ifPresent: [:mbr | mbrSet addAll: mbr]].
	^ mbrSet.
"	| ct mbrSet callStack |
	mbrSet := Set new.
	callStack := thisContext contextStack.
	callStack do: [:each |
		PhAspectWeaver objectMembranes at: (each receiver) ifPresent: [:mbr | mbrSet addAll: mbr] ].
	^ mbrSet"! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 6/20/2011 17:46'!
currentObjectDeployedMembraneStack
	^ PhMembraneMethodWrapper currentObjectDeployedMembraneStack ifEmpty: [self activeObjectDeployedMembraneSet asArray]! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 12:53'!
currentProcessMembraneStack
	^ PhMembraneMethodWrapper currentProcessMembraneStack ifEmpty: [self membranes select: [:mbr | mbr isBaseMembrane]] ! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:51'!
getAdviceFrom: aMembraneSet
	| aspectsSet advice |
	aspectsSet := Set new.
	advice := OrderedCollection new.
	aMembraneSet do: [ :each | aspectsSet addAll: each registeredAspects ].
	aspectsSet
		do: [ :asp | 
			asp adviceCollection
				do: [ :adv | 
					(adv pointcut includes: self selector on: self wrappedClass)
						ifTrue: [ advice add: adv ] ] ].
	advice := PhAspectWeaver setPrecedenceOn: (PhAspectWeaver setInheritancePrecedenceOn: advice asArray).
	^ advice! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 18:28'!
getAdviceFrom: aMembraneSet and: objMembraneSet
	| aspectsSet advice |
	aspectsSet := Set new.
	advice := OrderedCollection new.
	aMembraneSet do: [ :each | aspectsSet addAll: each registeredAspects ].
	objMembraneSet do: [:each | aspectsSet addAll: each registeredAspects ].
	aspectsSet
		do: [ :asp | 
			asp adviceCollection
				do: [ :adv | 
					(adv pointcut includes: self selector on: self wrappedClass)
						ifTrue: [ advice add: adv ] ] ].
	advice := PhAspectWeaver setPrecedenceOn: (PhAspectWeaver setInheritancePrecedenceOn: advice asArray).
	^ advice! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:45'!
getMembraneSetFor: activeMembranes
	activeMembranes 
		ifEmpty: [^ self membranes select: [:mbr | mbr isBaseMembrane ]]
		ifNotEmpty: [:mbrGrp | 
			| mbrSet |
			mbrSet := Set new.
			mbrGrp do: [:each | mbrSet addAll: each advisingMembranes].
			mbrSet := mbrSet select: [:mb | (mb pointcut = nil) or: [mb pointcut includes: (self selector) on: self wrappedClass]].
			^ mbrSet] ! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 02:12'!
getObjectDeployedMembraneSetFor: activeMembranes
	activeMembranes 
		ifEmpty: [^ self activeObjectDeployedMembraneSet select: [:mbr | mbr isBaseMembrane ]]
		ifNotEmpty: [:mbrGrp | 
			| mbrSet |
			mbrSet := Set new.
			mbrGrp do: [:each | mbrSet addAll: each advisingMembranes].
			mbrSet := mbrSet select: [:mb | (mb pointcut = nil) or: [mb pointcut includes: (self selector) on: self wrappedClass]].
			^ mbrSet] ! !

!PhMembraneMethodWrapper methodsFor: 'accessing' stamp: 'dgg 4/28/2011 20:11'!
membranes
	^ membranes! !

!PhMembraneMethodWrapper methodsFor: 'accessing' stamp: 'dgg 4/28/2011 20:12'!
membranes: aMembraneArray
	membranes := aMembraneArray! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 13:06'!
run: aSelector with: arguments in: aReceiver
	| result membraneStack advice advMembranes objectDeployedMembraneStack objAdvMembranes objectStart stackStart |
	PhMembraneMethodWrapper stackObjectOnCurrentProcess:  aReceiver. 
	membraneStack := self currentProcessMembraneStack.
	objectDeployedMembraneStack := self currentObjectDeployedMembraneStack.
	advMembranes := self getMembraneSetFor:  membraneStack.
	objAdvMembranes := self getObjectDeployedMembraneSetFor:  objectDeployedMembraneStack.
	advice := self getAdviceFrom:  advMembranes and: objAdvMembranes. 
	objectStart := PhMembraneMethodWrapper currentObjectDeployedMembraneStack isEmpty.
	stackStart := PhMembraneMethodWrapper currentProcessMembraneStack isEmpty.
	result :=  (PhAdviceGroup new)
		adviceCollection: advice;
		advisingMembranes: advMembranes;
		objectDeployedAdvisingMembranes: objAdvMembranes;
		wrapper: self;
		run: aSelector with: arguments in: aReceiver.
	PhMembraneMethodWrapper popObjectOnCurrentProcess.
	objectStart ifTrue: [self setObjectDeployedActiveMembranes: #()].
	stackStart ifTrue: [self setActiveMembranes: #()].
	^ result.! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/15/2011 18:18'!
setActiveMembranes:  aMembraneArray 
	PhMembraneMethodWrapper setActiveMembranes:  aMembraneArray ! !

!PhMembraneMethodWrapper methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:21'!
setObjectDeployedActiveMembranes:  aMembraneArray
	PhMembraneMethodWrapper  setObjectDeployedActiveMembranes:  aMembraneArray! !

!PhMethodWrapper methodsFor: 'private' stamp: 'dgg 4/28/2011 16:05'!
currentSender
	"thisContext contextStack inspect."
	(1 to: (thisContext contextStack) size) reverseDo: [:idx |
		(((thisContext contextStack) at: idx) receiver == self) ifTrue: [
			^(thisContext contextStack at: (idx+1)) receiver]].
	self error: 'sender not found'
	"^(thisContext contextStack at: 14) receiver"! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'dgg 4/28/2011 16:02'!
initialize
	super initialize.
	needCleanUp := false.! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'dgg 4/28/2011 16:02'!
install
	(self wrappedClass localSelectors includes: self selector) 
		ifTrue: [	needCleanUp := false.]
		ifFalse: [needCleanUp := true].
	"super install."
	oldMethod := self wrappedClass lookupSelector: self selector.
	[oldMethod isKindOf: self class] whileTrue: [oldMethod := oldMethod oldMethod].
	self wrappedClass methodDict at: self selector put: self! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'dgg 4/28/2011 16:05'!
needCleanUp
	^ needCleanUp! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'dgg 4/28/2011 16:05'!
needCleanUp: anObject
	needCleanUp := anObject! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'dgg 4/28/2011 16:02'!
uninstall
	self wrappedClass ifNil: [^self].
	super uninstall.
	needCleanUp ifTrue: [
		SystemChangeNotifier uniqueInstance doSilently: [self wrappedClass removeSelector: self selector]]! !

PPCompositeParser subclass: #PhPrecedenceRulesParser
	instanceVariableNames: 'letter word any identifier anysubclass identifierStar starIdentifierStar starAny'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPrecedenceRulesParser commentStamp: 'DanielGaldames 4/14/2011 01:54' prior: 0!
This class is responsable to parse the precedence rules defined on a pointcut or aspect.!

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:13'!
any
	^ $* asParser! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:13'!
anysubclass
	^$+ asParser! !

!PhPrecedenceRulesParser methodsFor: 'node set generation' stamp: 'DanielGaldames 3/25/2011 12:17'!
buildNodeSetFrom: aParserNode
	| aSet |
	aSet := Set new.
	((aParserNode at: 1) matches: (PhAspect name asString)) ifTrue: [aSet add: PhAspect].
	PhAspect allSubclasses do: [:asp |
		((aParserNode at: 1) matches: (asp name asString)) ifTrue: [aSet add: asp]].
	(aParserNode at: 2) notNil ifTrue: [
		| subs |
		subs := Set new.
		aSet do: [:asp | asp allSubclasses do: [:sub | subs add: sub]].
		subs do: [:asp | aSet add: asp.]].
	^aSet collect: [:asp | AspectNode new aspect: asp].! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:55'!
identifier
	^ (letter, word star) flatten! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/25/2011 11:56'!
identifierStar
	^ (identifier, any optional, anysubclass optional) ==> [:node |
		| precedenceParser|
		precedenceParser := (node at: 1) asParser.
		(node at: 2) notNil ifTrue: [precedenceParser := precedenceParser, #word asParser star].
		Array with: precedenceParser with: (node at: 3)]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:10'!
letter
	^ #letter asParser! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/29/2011 22:09'!
starAny
	^ (any) ==> [:node | Array with: (#word asParser star) with: nil]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/25/2011 12:21'!
starIdentifierStar
	^ (any, word plus flatten, any optional, anysubclass optional) ==> [:node |
		| precedeceParser |
		precedeceParser := (#word asParser starGreedy: ((node at: 2) asParser)), (node at: 2) asParser.
		(node at: 3) notNil ifTrue: [precedeceParser := precedeceParser, #word asParser star].
		Array with: precedeceParser with: (node at: 4)]! !

!PhPrecedenceRulesParser methodsFor: 'parser' stamp: 'DanielGaldames 3/25/2011 11:46'!
start
	^ (identifierStar / starIdentifierStar / starAny) end ==> [:node | self buildNodeSetFrom: node  ]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:56'!
word
	^ #word asParser! !

PPCompositeParser subclass: #PhReceiverParser
	instanceVariableNames: 'starToken nameToken plusToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

PhReceiverParser class
	instanceVariableNames: 'classAndSubclassAction subclassesAction metaNameAction nameAction'!

!PhReceiverParser commentStamp: 'DanielGaldames 4/14/2011 01:55' prior: 0!
this class is responsable to parse the receivers declared on a pointcut.!

PhReceiverParser class
	instanceVariableNames: 'classAndSubclassAction subclassesAction metaNameAction nameAction'!

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/21/2011 14:51'!
generateReceiverClassParser: aParserNode
	| aNameParser classParser |
	aNameParser := ((aParserNode at: 2) at: 1) asParser.
	(aParserNode at: 1) notNil ifTrue: [aNameParser := (#word asParser starGreedy: aNameParser), aNameParser].
	((aParserNode at: 2) at: 2) notNil ifTrue: [aNameParser := aNameParser, #word asParser star].
	classParser := #word asParser plus, (#space asParser plus), 'subclass:' asParser, (#space asParser plus), $# asParser, aNameParser, (#blank asParser | #newline asParser).
	"subclassParser := aNameParser, #space asParser plus, 'subclass:' asParser."
	(aParserNode at: 3) notNil
		ifTrue: [ | matchedClasses subclassParser |
			matchedClasses := (SmalltalkImage current allClasses) select: [:each |
				classParser matches: each definition].
			matchedClasses do: [:each |
				each allSubclasses do: [:s | classParser := classParser / s definition asParser]].
			^classParser]
		ifFalse: [^classParser]
	! !

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/21/2011 14:47'!
generateReceiverMetaclassParser: aParserNode
	| aNameParser metaclassParser |
	aNameParser := ((aParserNode at: 2) at: 1) asParser.
	(aParserNode at: 1) notNil ifTrue: [aNameParser := (#word asParser starGreedy: aNameParser), aNameParser].
	((aParserNode at: 2) at: 2) notNil ifTrue: [aNameParser := aNameParser, #word asParser star].
	metaclassParser := aNameParser, #space asParser plus, 'class' asParser,(#blank asParser | #newline asParser).
	(aParserNode at: 3) notNil
		ifFalse: [^metaclassParser]
		ifTrue: [
			| matchedMetaclasses |
			matchedMetaclasses := (SmalltalkImage current allClasses) collect: [:each | each class] thenSelect: [:each |
				metaclassParser matches: each definition].
			matchedMetaclasses do: [:each |
				each allSubclasses do: [:s | metaclassParser := metaclassParser / s definition asParser]].
			^metaclassParser.]! !

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/17/2011 21:02'!
generateReceiverParser: aParseNode
	^(((aParseNode at: 2) at: 3) notNil)
		ifTrue: [self generateReceiverMetaclassParser: aParseNode]
		ifFalse: [self generateReceiverClassParser: aParseNode]! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/16/2011 00:05'!
nameToken
	^((#letter asParser, #word asParser plus) flatten, starToken optional, ' class' asParser optional).! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/15/2011 23:14'!
plusToken
	^$+ asParser! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/15/2011 23:13'!
starToken
	^$* asParser! !

!PhReceiverParser methodsFor: 'parser' stamp: 'DanielGaldames 3/17/2011 20:38'!
start
	^((starToken optional, nameToken, plusToken optional) end) ==> [:node |
		self generateReceiverParser: node.]! !

PPCompositeParser subclass: #PhSelectorParser
	instanceVariableNames: 'identifier keyword unary binary multiword anyKeyUnary anyKeyMulti'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhSelectorParser commentStamp: 'DanielGaldames 4/14/2011 01:56' prior: 0!
this class is responsable to parse the selectors declared on a pointcut.!

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 18:50'!
anyKeyMulti
	^($_ asParser, $: asParser) ==> [:node | self identifier, $: asParser].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 19:09'!
anyKeyUnary
	^($_ asParser, $: asParser not) ==> [:node | self identifier].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:03'!
binary
	^ ((PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') ,
	  (PPPredicateObjectParser anyOf: '!!%&*+,/<=>?@\|~') star) flatten token ==> [:node | node value asParser]! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 14:12'!
identifier
	^ #letter asParser, #word asParser star! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:02'!
keyword
	^ (identifier , $: asParser) token ==> [:node | node value asParser].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 18:24'!
multiword
	^ (keyword | anyKeyMulti) plus! !

!PhSelectorParser methodsFor: 'parser' stamp: 'DanielGaldames 3/18/2011 19:05'!
start
	^ (unary / anyKeyUnary  / binary / multiword) end ==> [:node |
		(node isCollection) 
			ifTrue: [
				(node size > 1) 
					ifTrue:  [| p |
						p := node reduce: [:a :b | a,b].
						p end] 
					ifFalse: [(node at: 1) end]  ]
			ifFalse: [node end] ]! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:03'!
unary
	^ (identifier, $: asParser not) token ==> [:node | node value asParser]! !

Object subclass: #PhAdvice
	instanceVariableNames: 'type pointcut advice owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAdvice commentStamp: 'DanielGaldames 4/13/2011 23:36' prior: 0!
PhAdvice represents a pointcut, advice pair.
Use pointcut:  to declare the joinpoint to capture, using an instance of PhPointcut.
Use type: to declare the type of the advice,
	#before
	#after
	#around.
Use advice: to add the method to execute on the captued joinpoints.
advice: accept a block or a selector, with 0 arguments (if no context is captured on the pointcut), or 1 arguments for the context captured on the joinpoint.
you can also use selector:of: to send a message on an object for advice.
Example: 
	PhAdvice new
		pointcut: aPointcut;
		type: #before;
		advice: [:context | Transcript show: context receiver asString].
		
	PhAdvice new
		pointcut: aPointcut;
		type: #around;
		selector: #theAdviceOnFoo: of: foo.  !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:43'!
after: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #after.! !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:45'!
after: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #after.! !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:43'!
around: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #around! !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:45'!
around: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #around.! !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:43'!
before: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #before.! !

!PhAdvice classSide methodsFor: 'instance creation' stamp: 'johanfabry 10/6/2011 14:45'!
before: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #before.! !

!PhAdvice methodsFor: 'accessing' stamp: 'dgg 6/3/2011 13:16'!
advice: aBlock
	advice := aBlock! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/25/2011 22:15'!
owner
	^ owner ! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/25/2011 22:14'!
owner: anAspect
	owner := anAspect! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:50'!
pointcut
	^ pointcut! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:50'!
pointcut: aPhPointcut
	pointcut := aPhPointcut! !

!PhAdvice methodsFor: 'private' stamp: 'johanfabry 10/7/2011 16:43'!
run
	^(advice value: nil)! !

!PhAdvice methodsFor: 'private' stamp: 'dgg 6/3/2011 13:17'!
runWithin: aContext
	^(advice value: aContext)! !

!PhAdvice methodsFor: 'accessing' stamp: 'johanfabry 10/7/2011 16:43'!
send: aSymbol to: anObject
	self advice: [:contxt | anObject perform: aSymbol with: contxt]! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:51'!
type
	^ type ifNil: [type := #before]! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:51'!
type: aSymbol
	type := aSymbol! !

Object subclass: #PhAdviceGroup
	instanceVariableNames: 'beforeAdvice aroundAdvice afterAdvice currentAdviceIndex wrapper advisingMembranes objectDeployedAdvisingMembranes adviceCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 4/24/2011 21:37'!
adviceCollection: anAdviceCollection
	adviceCollection := anAdviceCollection.
	beforeAdvice := (anAdviceCollection select: [:adv | adv type = #before]) asArray.
	aroundAdvice := (anAdviceCollection select: [:adv | adv type = #around]) asArray.
	afterAdvice := (anAdviceCollection select: [:adv | adv type = #after]) asArray reversed.! !

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 4/29/2011 15:44'!
advisingMembranes
	^ advisingMembranes! !

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 4/29/2011 15:44'!
advisingMembranes: aMembraneSet
	advisingMembranes := aMembraneSet! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 17:43'!
afterAdvice
	^ afterAdvice! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 17:43'!
afterAdvice: anAdviceCollection
	afterAdvice := anAdviceCollection.
	afterAdvice do: [:each | each type: #after]! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 18:36'!
aroundAdvice
	^ aroundAdvice! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 17:43'!
aroundAdvice: anAdviceCollection
	aroundAdvice := anAdviceCollection.
	aroundAdvice do: [:each | each type: #around]! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 17:43'!
beforeAdvice
	^ beforeAdvice! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 17:43'!
beforeAdvice: anAdviceCollection
	beforeAdvice := anAdviceCollection.
	beforeAdvice do: [:each | each type: #before]! !

!PhAdviceGroup methodsFor: 'private' stamp: 'dgg 4/26/2011 15:55'!
buildAdviceGroupFor: aContext
	aContext adviceDictionary at: #before put: beforeAdvice.
	aContext adviceDictionary at: #after put: afterAdvice.
	aContext adviceDictionary at: #around put: aroundAdvice.! !

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:24'!
objectDeployedAdvisingMembranes
	^ objectDeployedAdvisingMembranes! !

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:25'!
objectDeployedAdvisingMembranes: membraneArray
	objectDeployedAdvisingMembranes := membraneArray! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/26/2011 15:47'!
oldMethod
	^ self wrapper oldMethod! !

!PhAdviceGroup methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:41'!
run: aSelector with: arguments in: aReceiver
	| aResult |
	PhBeforeAdviceRunner new
		selector: aSelector;
		receiver: aReceiver;
		arguments: arguments;
		adviceGroup: self;
		advice: self beforeAdvice;
		run.
	aResult := PhAroundAdviceRunner new
		selector: aSelector;
		receiver: aReceiver;
		arguments: arguments;
		adviceGroup: self;
		advice: self aroundAdvice;
		run.
	PhAfterAdviceRunner new
		selector: aSelector;
		receiver: aReceiver;
		arguments: arguments;
		adviceGroup: self;
		advice: self afterAdvice;
		run.
	^aResult! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/24/2011 18:38'!
wrapper
	^wrapper! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'dgg 4/29/2011 13:10'!
wrapper: aPhMethodMethodWrapper
	wrapper := aPhMethodMethodWrapper! !

Object subclass: #PhAdviceRunner
	instanceVariableNames: 'advice index type selector receiver arguments adviceGroup previousMembraneSet previousObjectDeployedMembraneSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 13:02'!
addMembranes
	"self adviceGroup wrapper setActiveMembranes: (WeakSet withAll: (self adviceGroup advisingMembranes))."
	self adviceGroup wrapper setActiveMembranes: previousMembraneSet.
	self adviceGroup wrapper setObjectDeployedActiveMembranes:  previousObjectDeployedMembraneSet. ! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 01:28'!
addMembranesOf: currentAdvice
	| membraneSet objectDeployedMembraneSet |
	membraneSet := WeakSet new.
	objectDeployedMembraneSet := WeakSet new.
	membraneSet
		addAll: (self adviceGroup advisingMembranes select: [ :mbr | mbr registeredAspects includes: currentAdvice owner ]).
	objectDeployedMembraneSet
		addAll: (self adviceGroup objectDeployedAdvisingMembranes select: [:mbr | mbr registeredAspects includes: currentAdvice owner] ).
	self adviceGroup wrapper setActiveMembranes: membraneSet.
	self adviceGroup wrapper setObjectDeployedActiveMembranes:  objectDeployedMembraneSet.! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/25/2011 08:55'!
advice
	^ advice! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/25/2011 08:55'!
advice: anObject
	advice := anObject! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:23'!
adviceGroup
	^ adviceGroup! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:23'!
adviceGroup: anObject
	adviceGroup := anObject! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:09'!
arguments
	^ arguments! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:13'!
arguments: anObject
	arguments := anObject! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 15:56'!
buildAdviceGroupFor: aContext
	self adviceGroup buildAdviceGroupFor: aContext.
	aContext adviceRunner: self.      ! !

!PhAdviceRunner methodsFor: 'private' stamp: 'dgg 5/6/2011 01:00'!
buildContextFor: anAdvice
	| aContext contextExp buildAdviceContext |
	contextExp := (anAdvice pointcut context) collect: [:each | (each = #proceed) ifTrue: [#method] ifFalse: [each]].
	buildAdviceContext := contextExp includes: #advice.
	aContext := PhContext new.
	(buildAdviceContext) ifTrue: [
		contextExp := contextExp select: [:each | (each = #advice) not].
		self buildAdviceGroupFor: aContext..].
	(contextExp) do: [:each |
		 aContext perform: (each asString,':') asSymbol with: (self perform: each asSymbol)].
	(contextExp includes: #method) ifTrue: [
		aContext arguments: self arguments.
		aContext receiver: self receiver.
		aContext selector: self selector].
	(anAdvice pointcut dynamicContext) ifNotNilDo: [:block |
		block value: aContext value: thisContext].
	aContext adviceRunner: self.
	^ aContext! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 16:06'!
changeAdvice: anAdviceCollection continueAt: anIndex
	advice := anAdviceCollection.
	index := anIndex -1! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/25/2011 08:55'!
index
	^ index! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/25/2011 08:55'!
index: anObject
	index := anObject! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/3/2011 21:49'!
initialize
	super initialize.
	index := 1! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:24'!
method
	^ self adviceGroup wrapper oldMethod.! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/4/2011 01:45'!
proceed
	(index < advice size)
		ifFalse: [^ self method valueWithReceiver: receiver arguments: arguments]
		ifTrue: [^ self runNext]! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/4/2011 01:45'!
proceed: changedArguments
	self arguments: changedArguments.
	(index < advice size)
		ifFalse: [^ self method valueWithReceiver: receiver arguments: arguments]
		ifTrue: [^ self runNext]! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:09'!
receiver
	^ receiver! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:13'!
receiver: anObject
	receiver := anObject! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 6/20/2011 17:30'!
run
	| result |
	previousMembraneSet := self adviceGroup wrapper currentProcessMembraneStack.
	previousObjectDeployedMembraneSet := self adviceGroup wrapper currentObjectDeployedMembraneStack. 
	result := self runAdvice.
	self adviceGroup wrapper setActiveMembranes: previousMembraneSet.
	self adviceGroup wrapper setObjectDeployedActiveMembranes:  previousObjectDeployedMembraneSet.
	^ result! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/4/2011 00:20'!
runAdvice
	[ index <= advice size ]
		whileTrue: [ 
			| currentAdvice |
			currentAdvice := advice at: index.
			self addMembranesOf: currentAdvice.
			currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
				ifTrue: [ currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
				ifFalse: [ currentAdvice run ].
			index := index + 1 ]! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/15/2011 18:21'!
runNext
	| result currentAdvice currentMembranes |
	currentMembranes := self adviceGroup wrapper currentProcessMembraneStack.
	index := index + 1.
	currentAdvice := advice at: index.
	self addMembranesOf: currentAdvice.
	currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
		ifTrue: [ result := currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
		ifFalse: [ result := currentAdvice run ].
	self adviceGroup wrapper setActiveMembranes: currentMembranes.
	^ result! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:09'!
selector
	^ selector! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/26/2011 13:13'!
selector: anObject
	selector := anObject! !

!PhAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:24'!
sender
	^ self adviceGroup wrapper currentSender.! !

!PhAdviceRunner methodsFor: 'accessing' stamp: 'dgg 4/25/2011 09:31'!
type
	^ self subclassResponsibility! !

PhAdviceRunner subclass: #PhAfterAdviceRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAfterAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:21'!
changeAdvice: anAdviceCollection continueAt: anIndex
	super changeAdvice: anAdviceCollection continueAt: anIndex.
	adviceGroup afterAdvice: anAdviceCollection.! !

!PhAfterAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/25/2011 09:33'!
type
	^#after! !

PhAdviceRunner subclass: #PhAroundAdviceRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAroundAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:21'!
changeAdvice: anAdviceCollection continueAt:  anIndex
	super changeAdvice: anAdviceCollection continueAt: anIndex.
	adviceGroup aroundAdvice: anAdviceCollection.! !

!PhAroundAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 5/8/2011 23:08'!
runAdvice
	| aResult |
	advice notEmpty
		ifTrue: [ 
			[ index <= advice size ]
				whileTrue: [ 
					| currentAdvice |
					currentAdvice := advice at: index.
					self addMembranesOf: currentAdvice.  
					currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
						ifTrue: [ aResult := currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
						ifFalse: [ aResult := currentAdvice run ].
					index := index + 1] ]
		ifFalse: [
			self addMembranes. 
			aResult := adviceGroup oldMethod valueWithReceiver: self receiver arguments: self arguments ].
	^ aResult! !

!PhAroundAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/25/2011 09:33'!
type
	^#around! !

PhAdviceRunner subclass: #PhBeforeAdviceRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhBeforeAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/26/2011 13:21'!
changeAdvice: anAdviceCollection continueAt:  anIndex
	super changeAdvice: anAdviceCollection continueAt: anIndex.
	adviceGroup afterAdvice: anAdviceCollection.! !

!PhBeforeAdviceRunner methodsFor: 'as yet unclassified' stamp: 'dgg 4/25/2011 09:33'!
type
	^#before! !

Object subclass: #PhAspect
	instanceVariableNames: 'adviceCollection precedence classModifiers installed onMembranes membrane aspectMembrane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAspect commentStamp: 'DanielGaldames 4/13/2011 23:50' prior: 0!
PhAspect represent an Aspect, it has a collection of PhAdvices, an PhClassModifiers.
Use add: to add advices.
Use addClassModifier: to add a classModifier.
Use precedence: to specify the desired precedence on the installed aspects.
Use install to install it, and uninstall to uninstall the aspect.
Example:
	PhAspect new
		add: (PhAdvice new ...);
		addClassMofifier: (PhClassModifier new on: ...);
		precedence: 'PhAspectBigger+ PhAspectFoo'.!

!PhAspect methodsFor: 'accessing' stamp: 'dgg 5/29/2011 01:59'!
add: anAdvice
	anAdvice owner: self.
	adviceCollection add: anAdvice.
	"PhAspectWeaver cleanCache."! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 4/13/2011 22:39'!
addClassModifier: aClassModifier
	classModifiers add: aClassModifier.! !

!PhAspect methodsFor: 'private' stamp: 'DanielGaldames 3/20/2011 16:50'!
adviceCollection
	^ adviceCollection! !

!PhAspect methodsFor: 'private' stamp: 'dgg 6/23/2011 16:38'!
classModifiers
	^ classModifiers ! !

!PhAspect methodsFor: 'private' stamp: 'dgg 6/26/2011 12:58'!
getPointcuts
	| pcs |
	pcs := Set new.
	self adviceCollection do: [:adv |
		pcs addAll: adv pointcut getPointcuts].
	^ pcs! !

!PhAspect methodsFor: 'initialization' stamp: 'dgg 5/1/2011 21:17'!
initialize
	adviceCollection := OrderedCollection new.
	classModifiers := Set new.
	installed := false.
	onMembranes := Set new.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 6/26/2011 12:59'!
install
	membrane := PhMembrane new pointcut: self.
	aspectMembrane := PhMembrane new advise: membrane.
	self registerOn: aspectMembrane.
	membrane install.  
	"| pointcutSet pointcut |
	pointcutSet := Set new.
	self adviceCollection do: [:each |
		pointcutSet add: each pointcut].
	pointcutSet isEmpty ifFalse: [
		(pointcutSet size < 2) 
			ifTrue: [pointcut := pointcutSet asArray at: 1]
			ifFalse: [
				pointcut := pointcutSet asArray reduce: [:a :b |
					a por: b]]].
	membrane := PhMembrane new pointcut: pointcut.
	membrane install.
	self registerOn: membrane."! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 5/2/2011 13:48'!
installClassModification
	installed ifFalse: [
		classModifiers do: [:each | each install].
		installed := true]! !

!PhAspect methodsFor: 'private' stamp: 'dgg 5/1/2011 21:25'!
onMembranes
	^ onMembranes! !

!PhAspect methodsFor: 'private' stamp: 'dgg 5/1/2011 21:25'!
onMembranes: anObject
	onMembranes := anObject! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/25/2011 20:13'!
precedence
	^ precedence ifNil: [precedence := #()]  ! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/25/2011 20:13'!
precedence: aPrecedenceArray
	precedence := aPrecedenceArray! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 5/2/2011 13:50'!
registerOn: aMembrane
	aMembrane registerAspect: self.
	onMembranes add: aMembrane.
	self installClassModification.! !

!PhAspect methodsFor: 'accessing' stamp: 'dgg 5/29/2011 02:00'!
remove: anAdvice
	adviceCollection remove: anAdvice.
	"PhAspectWeaver cleanCache"! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 4/13/2011 22:39'!
removeClassModifier: aClassModifier
	classModifiers remove: aClassModifier! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 9/18/2011 14:54'!
uninstall
	self unregisterFrom: aspectMembrane.
	membrane uninstall.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 5/2/2011 13:49'!
uninstallClassModification
	"PhAspectWeaver unInstall: self"
	installed ifTrue: [
		classModifiers do: [:each | each uninstall].
		installed := false]! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'dgg 5/2/2011 14:56'!
unregisterFrom: aMembrane
	aMembrane unregisterAspect: self.
	onMembranes remove: aMembrane ifAbsent: nil.
	onMembranes isEmpty ifTrue: [self uninstallClassModification]! !

Object subclass: #PhAspectWeaver
	instanceVariableNames: ''
	classVariableNames: 'InstalledMembranes ObjectInstalledMembranes WrapperList'
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAspectWeaver commentStamp: 'DanielGaldames 4/14/2011 01:11' prior: 0!
This class is responsable to weave the aspects into the system.!

!PhAspectWeaver classSide methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/11/2011 01:29'!
activateSystemNotification
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Modified
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Removed
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #classRename:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Added
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Modified
		using: #methodModification:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Removed
		using: #methodRemoved:! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'dgg 5/11/2011 01:08'!
addAllAdvisingMembranesOf: aMembrane to: aSet
	(aSet includes: aMembrane) 
		ifTrue: [^self]
		ifFalse: [
			aSet add: aMembrane.
			aMembrane advisingMembranes do: [:mbr |
				self addAllAdvisingMembranesOf: mbr to: aSet]] ! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'dgg 4/28/2011 14:05'!
addMembrane: aMembrane
	self installedMembranes add: aMembrane.. ! !

!PhAspectWeaver classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/29/2011 19:03'!
addObjectDeployedMembranesPointcutsTo: aPointcutDict
	| membranes allMembranes cfPointcuts |
	membranes := Set new.
	allMembranes := Set new.
	cfPointcuts := OrderedCollection new.
	self objectMembranes keysDo: [:obj |
		((obj class allSelectors) difference: (ProtoObject allSelectors))
			do: [:each |
				cfPointcuts add: (Array with: (obj class) with: each)]].
	self objectMembranes do: [ :each | membranes addAll: each ].
	membranes do: [ :mbr | self addAllAdvisingMembranesOf: mbr to: allMembranes ].
	allMembranes
		do: [ :membrane | 
			(self getMembranePointcuts: membrane)
				do: [ :pointcut | aPointcutDict at: pointcut ifAbsent: [ aPointcutDict at: pointcut put: #() ] ] ].
	cfPointcuts do: [:pc | aPointcutDict at: pc ifAbsent: [aPointcutDict at: pc put: #()]].
	^ aPointcutDict! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'johanfabry 10/8/2011 11:42'!
classRename: anEvent
	anEvent item methodDict do: [:each |
		(each isKindOf: PhMethodWrapper)
			ifTrue: [
				each reference setClass: (anEvent item) methodSymbol: (each reference methodSymbol)]].
	self flushPointcutsMemo.
	PhPointcut resetMemoizedcd.
	self updateMembranes.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/10/2011 21:23'!
cleanWrappers
	WrapperList notEmpty 
		ifTrue: [
			WrapperList do: [:each | each uninstall ].
			WrapperList removeAll].! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:52'!
combineOrderOf: aSortedAdvicesCollection and: anotherSortedAdviceCollection
	| combinedCollection rest |
	combinedCollection := OrderedCollection new.
	rest := OrderedCollection new.
	combinedCollection addAll: aSortedAdvicesCollection.
	anotherSortedAdviceCollection reverseDo: [:each |
		(combinedCollection includes: each) 
			ifTrue: [	rest do: [:adv | combinedCollection add: adv after: each]. rest removeAll]
			ifFalse: [rest addFirst: each]].
	combinedCollection addAllFirst: rest.
	^combinedCollection  ! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'dgg 5/29/2011 16:46'!
compileAndInstallMembranes
	| pointcutDict aspectRulesDict membranes |
	pointcutDict := Dictionary new.
	membranes := Set new.
	self installedMembranes do: [: mbr |
		self addAllAdvisingMembranesOf: mbr to: membranes].
	membranes do: [:membrane |
		(self getMembranePointcuts: membrane) do: [:pointcut |
			pointcutDict at: pointcut
				ifPresent: [:membraneCollection |
					(membraneCollection includes: membrane) ifFalse: [membraneCollection add: membrane]]
				ifAbsent: [pointcutDict at: pointcut put: (OrderedCollection with: membrane)]]].
	self addObjectDeployedMembranesPointcutsTo: pointcutDict.
	WrapperList := self getMembraneWrapperListWith: pointcutDict.
	WrapperList do: [:each | each install]! !

!PhAspectWeaver classSide methodsFor: 'as yet unclassified' stamp: 'dgg 9/18/2011 01:27'!
deploy: aMembrane on: anObject
	self objectMembranes at: anObject
		ifPresent: [:col | col add: aMembrane]
		ifAbsent: [
			self objectMembranes at: anObject put: (Set with: aMembrane)].
	WeakRegistry default add: anObject executor: aMembrane.
	self updateMembranes.! !

!PhAspectWeaver classSide methodsFor: 'update' stamp: 'johanfabry 10/8/2011 10:45'!
flushPointcutsMemo
	"This could be optimised so that we dont need to do an allInstances"
	PhPointcut allInstances do: [:pc| pc memoizedpc: nil].
! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'dgg 5/11/2011 01:18'!
getMembranePointcuts: aMembrane
	aMembrane pointcut
		ifNotNilDo: [ :pc | ^ pc getPointcuts ]
		ifNil: [ 
			| pcSet |
			pcSet := Set new.
			aMembrane registeredAspects
				do: [ :asp | asp adviceCollection do: [ :adv | pcSet addAll: adv pointcut getPointcuts ] ].
			^ pcSet ]
		"aMembrane pointcut
		ifNotNilDo: [ :pc | ^ pc getPointcuts ]
		ifNil: [ 
			aMembrane advisedMembranes
				ifNil: [ ^ #() ]
				ifNotNil: [ 
					| pcSet |
					pcSet := Set new.
					aMembrane registeredAspects
						do: [ :asp | asp adviceCollection do: [ :adv | pcSet addAll: adv pointcut getPointcuts ] ].
					^ pcSet ] ]"! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'dgg 5/1/2011 15:15'!
getMembraneWrapperListWith: aPointcutDictionary
	| dict |
	dict := Dictionary new.
	aPointcutDictionary keysAndValuesDo: [:key :value |
		dict at: key put: (PhMembraneMethodWrapper on: (key at: 1) selector: (key at: 2) with: value asArray)].
	^dict  ! !

!PhAspectWeaver classSide methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/11/2011 01:29'!
initialize
	super initialize.
	self activateSystemNotification.
	WrapperList := Dictionary new.! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'dgg 5/1/2011 15:20'!
installMembrane: aMembrane
	self cleanWrappers.
	self addMembrane: aMembrane.
	self compileAndInstallMembranes! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'dgg 6/26/2011 13:34'!
installedAspects
	| aspectSet allMembranes |
	aspectSet := Set new.
	allMembranes := Set new.
	InstalledMembranes do: [:mbr | self addAllAdvisingMembranesOf: mbr to: allMembranes].
	allMembranes do: [:e | 
		aspectSet addAll: e registeredAspects].
	^ aspectSet.! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'dgg 5/15/2011 19:15'!
installedMembranes
	^ InstalledMembranes ifNil: [InstalledMembranes := Set new.]! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'dgg 5/1/2011 15:23'!
methodModification: anEvent
	(anEvent oldItem isKindOf: PhMethodWrapper)
		ifTrue: [ 
			anEvent oldItem oldMethod: anEvent item.
			anEvent oldItem needCleanUp: false.
			anEvent oldItem install ]! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'johanfabry 10/8/2011 10:46'!
methodRemoved: anEvent
	(anEvent item isKindOf: PhMethodWrapper)
		ifTrue: [WrapperList removeKey: (Array with: (anEvent itemClass) with: (anEvent item selector) )].
	self flushPointcutsMemo.
	self updateMembranes! !

!PhAspectWeaver classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/15/2011 22:26'!
objectMembranes
	^ ObjectInstalledMembranes ifNil: [ObjectInstalledMembranes := WeakKeyToCollectionDictionary  new]! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'dgg 6/26/2011 12:50'!
panicCleanAndResetAll
	self uninstallAll.
	self objectMembranes removeAll.
	PhMembraneMethodWrapper processMembraneStack removeAll.
	PhMembraneMethodWrapper processObjectStack removeAll.
	PhMembraneMethodWrapper processObjectDeployedMembraneStack.
	SmalltalkImage current garbageCollect.! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'dgg 4/28/2011 13:40'!
removeMembrane: aMembrane
	self installedMembranes remove: aMembrane ifAbsent: nil.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/19/2011 15:53'!
setInheritancePrecedenceOn: anAdviceCollection
	| aspectList adviceList workingSet tmp |
	aspectList := Set new.
	aspectList add: PhAspect.
	aspectList addAll: PhAspect allSubclasses.
	adviceList := OrderedCollection new.
	adviceList addAll: (anAdviceCollection select: [:adv | adv owner class theNonMetaClass = PhAspect]).
	workingSet := OrderedCollection with: PhAspect.
	tmp := OrderedCollection new.
	[aspectList notEmpty] whileTrue: [
		tmp removeAll.
		workingSet do: [:father |
			tmp addAll: (aspectList select: [:asp | asp superclass = father]).
			aspectList remove: father].
		tmp do: [:asp |
				adviceList addAll: (anAdviceCollection select: [:adv | adv owner class theNonMetaClass = asp])].
		workingSet removeAll.
		workingSet addAll: tmp].
	^ adviceList.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:09'!
setPrecedenceOn: anAdviceSet
	"ordenar basado en precedencia"
	| pointcutRulesSet pointcutOverrideRuleSet aspectRulesSet sortedAspects sortedAdvices |
	aspectRulesSet := Set new.
	pointcutRulesSet := Set new.
	pointcutOverrideRuleSet := Set new.
	anAdviceSet do: [:adv |
		(adv owner precedence notEmpty) ifTrue: [aspectRulesSet add: adv owner precedence].
		(adv pointcut precedence notEmpty) ifTrue: [
			(adv pointcut override) 
				ifFalse: [pointcutRulesSet add: adv pointcut precedence]
				ifTrue: [pointcutOverrideRuleSet add: adv pointcut precedence]]].
	((aspectRulesSet isEmpty) & (pointcutRulesSet isEmpty) & (pointcutOverrideRuleSet isEmpty)) ifTrue: [^anAdviceSet].
	(pointcutOverrideRuleSet isEmpty) 
		ifFalse: [
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: pointcutOverrideRuleSet.  
			sortedAdvices := self sort: anAdviceSet from: sortedAspects.  
			(anAdviceSet difference: sortedAdvices) do: [:e | sortedAdvices add: e].
			^sortedAdvices. ]
		ifTrue: [
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: pointcutRulesSet.
			sortedAdvices := self sort: anAdviceSet from: sortedAspects.
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: aspectRulesSet.
			sortedAdvices := self combineOrderOf: sortedAdvices and: (self sort: anAdviceSet from: sortedAspects).
			^sortedAdvices]! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:44'!
sort: anAdvicesCollection from: aSortedAspectCollection
	| sortedAdvices |
	sortedAdvices := OrderedCollection new.
	aSortedAspectCollection do: [:each |
		| col |
		col := anAdvicesCollection select: [:adv | adv owner class = each].
		col do: [:adv | sortedAdvices add: adv]].
	^sortedAdvices.! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'johanfabry 10/8/2011 11:42'!
systemEvent: anEvent
	self flushPointcutsMemo.
	PhPointcut resetMemoizedcd.
	self updateMembranes.! !

!PhAspectWeaver classSide methodsFor: 'as yet unclassified' stamp: 'johanfabry 10/7/2011 22:02'!
undeploy:  aMembrane from: anObject
	self objectMembranes at: anObject 
		ifPresent: [:value | 
			| update |
			update = true.
			value remove: aMembrane ifAbsent: [update := false].
			update ifTrue: [self updateMembranes ]]! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'dgg 5/1/2011 15:20'!
uninstallAll
	self installedMembranes removeAll.
	self cleanWrappers.  ! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'dgg 5/1/2011 15:20'!
uninstallMembrane: aMembrane
	self cleanWrappers.
	self removeMembrane: aMembrane.
	self compileAndInstallMembranes! !

!PhAspectWeaver classSide methodsFor: 'update' stamp: 'johanfabry 10/7/2011 21:59'!
updateMembranes
	
	self cleanWrappers.
	self compileAndInstallMembranes! !

Object subclass: #PhClassModifier
	instanceVariableNames: 'pointcut newInstanceMethodDict newClassMethodDict newInstanceVar newClassVar modifiedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhClassModifier commentStamp: 'DanielGaldames 4/14/2011 01:22' prior: 0!
This class is use to declare the modification to do on a class, at the moment of install an aspect.
You can add instance variables, class variables, instance methods and class side methods.
This modifications are rolled back on uninstall.!

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:24'!
on: aPointcut addCM: aCMString
	^self new on: aPointcut; addNewClassMethod: aCMString
  ! !

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:24'!
on: aPointcut addCV: aCVString
	^self new on: aPointcut; addNewClassVar: aCVString! !

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:24'!
on: aPointcut addCV: aCVString addCM: aCMString
	^self new on: aPointcut; addNewClassVar: aCVString; addNewClassMethod: aCMString
  ! !

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:25'!
on: aPointcut addIM: aIMString
	^self new on: aPointcut; addNewInstanceMethod: aIMString   
	! !

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:25'!
on: aPointcut addIV: aIVString
	^self new on: aPointcut; addNewInstanceVar: aIVString! !

!PhClassModifier classSide methodsFor: 'instance creation' stamp: 'dgg 9/29/2011 14:25'!
on: aPointcut addIV: aIVString addIM: aIMString
	^self new on: aPointcut; addNewInstanceVar: aIVString; addNewInstanceMethod: aIMString   
	! !

!PhClassModifier methodsFor: 'method-manipulation' stamp: 'dgg 9/29/2011 11:59'!
addNewClassMethod: aMethodString
	| aSelector |
	aSelector := (RBParser parseMethod: aMethodString) selector.
	modifiedClasses do: [:class |
		(class theMetaClass allSelectors includes: aSelector)
			ifFalse: [newClassMethodDict add: (aSelector -> aMethodString)]
			ifTrue: [self error: 'method already defined']]
	"(modifiedClass theMetaClass allSelectors includes: aSelector)
		ifFalse: 	[newClassMethodDict add: (aSelector -> aMethodString)]
		ifTrue: [self error: 'method already defined']"! !

!PhClassModifier methodsFor: 'variable-manipulation' stamp: 'dgg 9/29/2011 12:03'!
addNewClassVar: aClassVarName
	| varName |
	varName := aClassVarName capitalized.
	modifiedClasses do: [:class |
		(class hasClassVarNamed: varName)
			ifFalse: [newClassVar add: varName]
			ifTrue: [self error: 'variable already defined']]
	"(modifiedClass hasClassVarNamed: varName) 
		ifFalse:	[newClassVar add: varName]
		ifTrue: [self error: 'variable already defined']"! !

!PhClassModifier methodsFor: 'method-manipulation' stamp: 'dgg 9/29/2011 13:57'!
addNewInstanceMethod: aMethodString
	| aSelector |
	aSelector := (RBParser parseMethod: aMethodString) selector.
	modifiedClasses do: [:each |
		(each allSelectors includes: aSelector)
			ifFalse: [newInstanceMethodDict add: (aSelector -> aMethodString)]
			ifTrue: [self error: 'method already defined']]
	"(modifiedClass allSelectors includes: aSelector)
		ifFalse: 	[newInstanceMethodDict add: (aSelector -> aMethodString)]
		ifTrue: [self error: 'method already defined']"! !

!PhClassModifier methodsFor: 'variable-manipulation' stamp: 'dgg 9/29/2011 14:00'!
addNewInstanceVar: anInstanceVarName
	modifiedClasses do: [:each | 
		(each hasInstVarNamed: anInstanceVarName)
			ifFalse:	[newInstanceVar add: anInstanceVarName]
			ifTrue: [self error: 'variable already defined']]
	"(modifiedClass hasInstVarNamed: anInstanceVarName) 
		ifFalse:	[newInstanceVar add: anInstanceVarName]
		ifTrue: [self error: 'variable already defined']"! !

!PhClassModifier methodsFor: 'private' stamp: 'dgg 9/29/2011 15:48'!
checkExistence
	modifiedClasses
		do: [ :modifiedClass | 
			newInstanceVar
				do: [ :varName | 
					(modifiedClass theNonMetaClass hasInstVarNamed: varName)
						ifTrue: [ self error: 'instance variable already defined!!' ] ].
			newClassVar
				do: [ :varName | 
					(modifiedClass theNonMetaClass hasClassVarNamed: varName)
						ifTrue: [ self error: 'class variable already defined!!' ] ].
			newInstanceMethodDict
				keysDo: [ :selector | 
					(modifiedClass theNonMetaClass allSelectors includes: selector)
						ifTrue: [ self error: 'instance method already defined!!' ] ].
			newClassMethodDict
				keysDo: [ :selector | 
					(modifiedClass theMetaClass allSelectors includes: selector)
						ifTrue: [ self error: 'class method already defined!!' ] ] ]
	"newInstanceVar do: [:varName |
		(modifiedClass theNonMetaClass hasInstVarNamed: varName) ifTrue: [self error: 'instance variable already defined!!']].
	newClassVar do: [:varName |
		(modifiedClass theNonMetaClass hasClassVarNamed: varName) ifTrue: [self error: 'class variable already defined!!']].
	newInstanceMethodDict keysDo: [:selector |
		(modifiedClass theNonMetaClass allSelectors includes: selector) ifTrue: [self error: 'instance method already defined!!']].
	newClassMethodDict keysDo: [:selector |
		(modifiedClass theMetaClass allSelectors includes: selector) ifTrue: [self error: 'class method already defined!!']]"! !

!PhClassModifier methodsFor: 'private' stamp: 'dgg 9/29/2011 14:04'!
compileClassMethod: aMethodString
	modifiedClasses do: [:modifiedClass |
		modifiedClass theMetaClass compile: aMethodString classified: '*phantom-generated-method']
	! !

!PhClassModifier methodsFor: 'private' stamp: 'dgg 9/29/2011 14:04'!
compileMethod: aMethodString
	modifiedClasses do: [:modifiedClass |
		modifiedClass compile: aMethodString classified: '*phantom-generated-method'  ]
	! !

!PhClassModifier methodsFor: 'as yet unclassified' stamp: 'dgg 9/29/2011 13:35'!
filterMatchedClasses: aClassCollection
	"fliter classes by object hierarchy"
	| filteredCollection |
	filteredCollection := OrderedCollection withAll: aClassCollection.
	aClassCollection do: [:each |
		| subclasses |
		subclasses := each allSubclasses.
		filteredCollection := filteredCollection reject: [:class | subclasses includes: class]].
	^ filteredCollection
	! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/13/2011 20:19'!
initialize
	newInstanceMethodDict := Dictionary new.
	newClassMethodDict := Dictionary new.
	newInstanceVar := Set new.
	newClassVar := Set new.! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'dgg 9/29/2011 15:48'!
install
	modifiedClasses := self filterMatchedClasses: pointcut getMatchedClasses.
	self checkExistence.
	modifiedClasses
		do: [ :modifiedClass | 
			newInstanceVar do: [ :varName | modifiedClass theNonMetaClass addInstVarNamed: varName ].
			newClassVar do: [ :varName | modifiedClass theNonMetaClass addClassVarNamed: varName ].
			newClassMethodDict do: [ :methodString | self compileClassMethod: methodString ].
			newInstanceMethodDict do: [ :methodString | self compileMethod: methodString ] ]! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'dgg 9/29/2011 13:36'!
on: aPointcut
	pointcut := aPointcut.
	modifiedClasses := self filterMatchedClasses:  (aPointcut getMatchedClasses).! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 20:23'!
removeClassVar: aClassVarName
	newClassVar remove: aClassVarName! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 20:24'!
removeInstanceVar: anIntanceVarName
	newInstanceVar remove: anIntanceVarName! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'dgg 9/29/2011 14:07'!
uninstall
	modifiedClasses
		do: [ :modifiedClass | 
			newClassMethodDict keysDo: [ :selector | modifiedClass theMetaClass removeSelector: selector ].
			newInstanceMethodDict keysDo: [ :selector | modifiedClass theNonMetaClass removeSelector: selector ].
			modifiedClass organization removeEmptyCategories.
			modifiedClass theMetaClass organization removeEmptyCategories.
			newClassVar do: [ :classVarName | modifiedClass theNonMetaClass removeClassVarNamed: classVarName ].
			newInstanceVar do: [ :instanceVarName | modifiedClass theNonMetaClass removeInstVarNamed: instanceVarName ] ]! !

Object subclass: #PhContext
	instanceVariableNames: 'receiver arguments selector method sender dynamicContext adviceDictionary adviceRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhContext commentStamp: 'DanielGaldames 4/14/2011 01:28' prior: 0!
This class is used to pass the context of execution to the advices on aspects!

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:57'!
adviceDictionary
	^adviceDictionary ! !

!PhContext methodsFor: 'accessing' stamp: 'dgg 4/25/2011 09:07'!
adviceRunner
	^adviceRunner! !

!PhContext methodsFor: 'accessing' stamp: 'dgg 4/25/2011 09:06'!
adviceRunner: anAdviceRunner
	adviceRunner := anAdviceRunner! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:57'!
afterAdvice
	^ adviceDictionary at: #after! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/26/2011 15:58'!
afterAdvice: adviceCollection
	adviceDictionary at: #after put: adviceCollection asArray.
	adviceRunner adviceGroup afterAdvice: (adviceDictionary at: #after)! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
arguments
	^ arguments! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
arguments: anObject
	arguments := anObject! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:57'!
aroundAdvice
	^ adviceDictionary at: #around! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/26/2011 15:58'!
aroundAdvice: adviceCollection
	adviceDictionary at: #around put: adviceCollection asArray.
	adviceRunner adviceGroup aroundAdvice: (adviceDictionary at: #around)  ! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:56'!
beforeAdvice
	^ adviceDictionary at: #before! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/26/2011 15:58'!
beforeAdvice: adviceCollection
	adviceDictionary at: #before put: adviceCollection asArray.
	adviceRunner adviceGroup beforeAdvice: (adviceDictionary at: #before)  ! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/25/2011 09:17'!
currentAdvice
	^ adviceDictionary at: (adviceRunner type)! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/25/2011 09:17'!
currentAdvice: anAdviceCollection continueAt: anIndex
	adviceDictionary at: (adviceRunner type) put: anAdviceCollection asArray.
	"wrapper perform: ((currentAdviceGroup, 'Advice:') asSymbol) with: (adviceDictionary at: currentAdviceGroup).
	wrapper currentAdviceIndex: (anIndex -1)"
	adviceRunner changeAdvice: anAdviceCollection continueAt: anIndex.! !

!PhContext methodsFor: 'advices' stamp: 'dgg 4/25/2011 09:21'!
currentAdviceIndex
	^adviceRunner index.! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:40'!
dynamicContext
	^dynamicContext! !

!PhContext methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/18/2011 12:57'!
initialize
	super initialize.
	dynamicContext := Dictionary new.
	adviceDictionary := Dictionary	newFrom: {
		#before -> nil.
		#after -> nil.
		#around -> nil}! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
method
	^ method! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
method: anObject
	method := anObject! !

!PhContext methodsFor: 'proceed' stamp: 'dgg 5/3/2011 21:55'!
proceed
	^ adviceRunner proceed.  ! !

!PhContext methodsFor: 'proceed' stamp: 'dgg 5/3/2011 21:55'!
proceed: args
	^ adviceRunner proceed: args.  ! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
receiver
	^ receiver! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
receiver: anObject
	receiver := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
selector
	^ selector! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
selector: anObject
	selector := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 14:03'!
sender
	^ sender! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 14:03'!
sender: aSender
	sender := aSender! !

Object subclass: #PhMembrane
	instanceVariableNames: 'advisedMembranes pointcut registeredAspects advisingMembranes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhMembrane methodsFor: 'public' stamp: 'johanfabry 10/7/2011 22:07'!
advise: aMembrane
	self advisedMembranes add: aMembrane.
	aMembrane advisingMembranes add: self.
	PhAspectWeaver updateMembranes.
	"self advisedMembranes do: [:each | each advisingMembranes add: self]"! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 4/27/2011 19:42'!
advisedMembranes
	^ advisedMembranes ifNil: [advisedMembranes := Set new]! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 4/27/2011 19:41'!
advisedMembranes: aMembraneSet
	advisedMembranes := aMembraneSet! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 5/1/2011 23:42'!
advisingMembranes
	^ advisingMembranes ifNil: [advisingMembranes := Set new.]! !

!PhMembrane methodsFor: 'public' stamp: 'dgg 5/29/2011 15:10'!
deployOn: anObject
	PhAspectWeaver deploy: self on: anObject.! !

!PhMembrane methodsFor: 'finalization' stamp: 'johanfabry 10/7/2011 22:09'!
finalize
	PhAspectWeaver updateMembranes.! !

!PhMembrane methodsFor: 'public' stamp: 'dgg 5/10/2011 22:56'!
install
	PhAspectWeaver installMembrane: self.
	"self advisedMembranes do: [:each | each advisingMembranes add: self]"! !

!PhMembrane methodsFor: 'testing' stamp: 'dgg 4/28/2011 17:14'!
isBaseMembrane
	^ self advisedMembranes isEmpty  ! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 4/27/2011 19:40'!
pointcut
	^ pointcut! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 4/27/2011 19:41'!
pointcut: aPhPointcut
	pointcut := aPhPointcut! !

!PhMembrane methodsFor: 'public' stamp: 'johanfabry 10/7/2011 22:06'!
registerAspect: anAspect
	self registeredAspects add: anAspect.
	anAspect onMembranes add: self.
	PhAspectWeaver updateMembranes.! !

!PhMembrane methodsFor: 'accessing' stamp: 'dgg 4/27/2011 19:42'!
registeredAspects
	^ registeredAspects ifNil: [registeredAspects := Set new]! !

!PhMembrane methodsFor: 'public' stamp: 'dgg 5/10/2011 22:57'!
unAdvise: aMembrane
	self advisedMembranes remove: aMembrane.
	aMembrane advisingMembranes remove: self.! !

!PhMembrane methodsFor: 'public' stamp: 'dgg 5/29/2011 15:17'!
undeployFrom: anObject
	PhAspectWeaver undeploy: self from: anObject! !

!PhMembrane methodsFor: 'public' stamp: 'dgg 5/10/2011 23:01'!
uninstall
	PhAspectWeaver uninstallMembrane: self.
	"self registeredAspects do: [:each | each unregisterFrom: self]".
	"self advisedMembranes do: [:each | each advisingMembranes remove: self ifAbsent: nil]"! !

!PhMembrane methodsFor: 'public' stamp: 'johanfabry 10/8/2011 11:50'!
unregisterAspect: anAspect
	self registeredAspects remove: anAspect ifAbsent: nil.
	anAspect onMembranes remove: self ifAbsent: nil.
	
	self flag: 'I dont understand why I need to flush memoization caches here --JF'.
	PhAspectWeaver flushPointcutsMemo.
	PhPointcut resetMemoizedcd.
	
	PhAspectWeaver updateMembranes.! !

Object subclass: #PhPointcut
	instanceVariableNames: 'selectors receivers pointcut composition selectIfMatch context precedence overrideRules dynamicContextBlock selectorsMessage packageRestriction cachedRecParser cachedSelParser memoizedpc'
	classVariableNames: 'Memoizedcd Modifiers'
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPointcut commentStamp: 'DanielGaldames 4/14/2011 01:58' prior: 0!
This class is used to define a pointcut.
The joinpoint model is based on messsage reception.
You have to define the receivers of the message, and the message (selectors).
Example:
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: 'foo:'.
	
	To select the metaclass:
	Example:
	PhPointcut new
		receivers: 'PhMockClass class';
		selectors: 'foo:'.
		
You can use some wildcards (like in AspectJ).
Example:
	Any receiver that have MockClass on his name.
	PhPointcut new
		receivers: '*MockClass*';
		selectors: 'foo:'.
		
	PhMockClass and all its subclasses:
	PhPointcut new
		receivers: 'PhMockClass+';
		selectors: 'foo:'.
		
On the selectors you can use '_' for any non argument selector, or '_:' any selector that receive an argument:
Example:
	Any selector of PhMockClass that receive a two argument message.
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: '_:_:'.
		
You can pass groups of receivers and selectors as Arrays
Example:
	PhPointcut new
		receivers: #('Foo' 'Bar' 'SomeClass');
		selectors: #('foo:' 'bar').

You can also pass a PetitParser parser as receivers or selectors.
The classes definition that mathces the parser will be selected as receivers.
On the selectors, the selectors that matches the parser will be selected.

You can define the context to pass to the advices:
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: 'foo:';
		context: #(#receiver #sender #selector #arguments #proceed).
		
You can override the precedence on defined on an aspect with overridePrecedence: #(...).
You can define a different precedence with precedence: #(...), this precedence has higher priority than the precedence defined on the aspects.
You can combine pointcuts using (and) pand: , (or) por: , and not.
Example: 
	(aPointcut1 pand: aPoincut2) por: aPointcut3.!

!PhPointcut classSide methodsFor: 'accessing' stamp: 'johanfabry 10/8/2011 11:33'!
memoizedcd
	Memoizedcd isNil ifTrue:[
		Memoizedcd := SmalltalkImage current allClasses collect: [:cl| cl -> {cl definition . cl class definition}]].
	^ Memoizedcd! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/10/2011 10:06'!
receivers: aReceivers localSelectors: aSelectors
	^ self new receivers: aReceivers; localSelectors: aSelectors.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/10/2011 10:06'!
receivers: aReceivers localSelectors: aSelectors context: aContext
	^ self new receivers: aReceivers; localSelectors: aSelectors; context: aContext.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/10/2011 10:06'!
receivers: aReceivers localSelectors: aSelectors context: aContext restrict: aRestriction
	^ self new receivers: aReceivers; localSelectors: aSelectors; context: aContext; restrictToPackages: aRestriction.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/10/2011 10:06'!
receivers: aReceivers localSelectors: aSelectors restrict: aRestriction
	^ self new receivers: aReceivers; localSelectors: aSelectors; restrictToPackages: aRestriction.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/1/2011 15:33'!
receivers: aReceivers selectors: aSelectors
	^ self new receivers: aReceivers; selectors: aSelectors.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/1/2011 15:34'!
receivers: aReceivers selectors: aSelectors context: aContext
	^ self new receivers: aReceivers; selectors: aSelectors; context: aContext.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/1/2011 15:35'!
receivers: aReceivers selectors: aSelectors context: aContext restrict: aRestriction
	^ self new receivers: aReceivers; selectors: aSelectors; context: aContext; restrictToPackages: aRestriction.! !

!PhPointcut classSide methodsFor: 'instance creation' stamp: 'johanfabry 6/1/2011 15:35'!
receivers: aReceivers selectors: aSelectors restrict: aRestriction
	^ self new receivers: aReceivers; selectors: aSelectors; restrictToPackages: aRestriction.! !

!PhPointcut classSide methodsFor: 'utility' stamp: 'DanielGaldames 3/14/2011 01:39'!
receviersParser
	^ PhReceiverParser new.! !

!PhPointcut classSide methodsFor: 'accessing' stamp: 'johanfabry 10/8/2011 11:34'!
resetMemoizedcd
	Memoizedcd := nil! !

!PhPointcut classSide methodsFor: 'utility' stamp: 'DanielGaldames 3/18/2011 22:29'!
selectorsParser
	^ PhSelectorParser new.! !

!PhPointcut methodsFor: 'composing' stamp: 'dgg 9/18/2011 17:34'!
& aPointcut
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: aPointcut;
		composition: #intersection:;
		selectIfMatch: self selectIfMatch;
		context: (self mergeContext: aPointcut);
		precedence: self precedence;
		override: self override;
		selectorsMessage: selectorsMessage;
		restrictToPackages: packageRestriction;  
		yourself.    ! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 6/3/2011 19:31'!
checkContextDefinition: anArray
	| validContextDefs |
	validContextDefs := #(#receiver #sender #selector #arguments #proceed #advice).
	anArray do: [:each |
		(validContextDefs anySatisfy: [:df | df = each])
			ifFalse: [^ false]].
	^ true! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
composition
	^ composition! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
composition: anObject
	composition := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 12:46'!
context
	^ context ifNil: [context := #()]  ! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 6/3/2011 13:49'!
context: anArray 
	(self checkContextDefinition: anArray)
		ifTrue: [	context := anArray ]
		ifFalse: [self error: 'bad context definition']! !

!PhPointcut methodsFor: 'private' stamp: 'johanfabry 10/7/2011 21:06'!
createPointcutList
	| aSet classes receiversParser selectorsParser |

	self memoizedpc isNil ifFalse: [^self memoizedpc].
	
	aSet := Set new.
	receiversParser := self parseReceivers: receivers.
	selectorsParser := self parseSelectors: selectors.
	selectIfMatch
		ifTrue: [ 
			self getClassList
				do: [ :each | aSet addAll: (self pointcutsThatMatchOf: each receiversParser: receiversParser selectorsParser: selectorsParser) ] ]
		ifFalse: [ 
			self getClassList
				do: [ :each | aSet addAll: (self pointcutsThatDontMatchOf: each receiversParser: receiversParser selectorsParser: selectorsParser) ] ].
	
	self memoizedpc: aSet.  
	^ aSet! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:46'!
dynamicContext
	^dynamicContextBlock! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:46'!
dynamicContext: aContextCreatorBlock
	dynamicContextBlock := aContextCreatorBlock! !

!PhPointcut methodsFor: 'private' stamp: 'johanfabry 10/8/2011 12:10'!
getClassList
	packageRestriction isEmpty
		ifTrue: [ ^ PhPointcut memoizedcd ]
		ifFalse: [ 
			| classes |
			classes := Set new.
			packageRestriction
				do: [ :packageName | 
					| package |
					package := PackageOrganizer default packageNamed: packageName ifAbsent: nil.
					package ifNotNil: [ classes addAll: (package classes select: [ :cl | (cl isKindOf: Trait) not ]) ] ].
			^ classes collect: [:cl | cl -> ({cl definition . cl class definition})]]! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 9/29/2011 11:45'!
getMatchedClasses
	^ (self getPointcuts collect: [:pair | pair at: 1]) asOrderedCollection.! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 5/6/2011 02:24'!
getPointcuts
	| pointcuts |
	pointcuts := self createPointcutList.
	(self pointcut notNil) ifTrue: [
		pointcuts := pointcuts perform: (self composition) with: (self pointcut getPointcuts)  ].
	^pointcuts
	! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 5/1/2011 16:38'!
includes: aSelector on: aClass
	(self
		packageRestrictionIncludes: aClass)
		ifTrue: [ 
			| classParser selectorParser |
			classParser := self parseReceivers: self receivers.
			selectorParser := self parseSelectors: self selectors.
			selectIfMatch
				ifTrue: [ 
					(classParser matches: aClass definition)
						ifTrue: [ ^ selectorParser matches: aSelector asString]
						ifFalse: [^ false] ]
				ifFalse: [
					(classParser matches: aClass definition)
						ifTrue: [ ^ (selectorParser matches: aSelector asString) not ]
						ifFalse: [^true]] ]
		ifFalse: [ ^ false ]! !

!PhPointcut methodsFor: 'initialize-release' stamp: 'dgg 5/6/2011 01:39'!
initialize
	pointcut := nil.
	composition := nil.
	selectIfMatch := true.
	overrideRules := false.
	dynamicContextBlock := nil.
	selectorsMessage := #allSelectors.
	packageRestriction := #()! !

!PhPointcut methodsFor: 'accessing' stamp: 'johanfabry 6/10/2011 10:09'!
localSelectors: aParserOrString
	self setLocal: true.  
	aParserOrString = #()
		ifTrue: [selectors := #any asParser]
		ifFalse: [selectors := aParserOrString]
! !

!PhPointcut methodsFor: 'accessing' stamp: 'johanfabry 10/7/2011 21:07'!
memoizedpc
	^ memoizedpc! !

!PhPointcut methodsFor: 'accessing' stamp: 'johanfabry 10/7/2011 21:07'!
memoizedpc: anObject
	memoizedpc := anObject! !

!PhPointcut methodsFor: 'composing' stamp: 'johanfabry 6/12/2011 21:03'!
mergeContext: aPointcut
	|newctx|
	newctx := self context asSet.
	newctx addAll: aPointcut context.
	^newctx asArray.  
	! !

!PhPointcut methodsFor: 'composing' stamp: 'johanfabry 6/12/2011 21:07'!
not
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: (self pointcut ifNotNil: [self pointcut not]);
		composition: ((self composition) ifNotNil: [
			(self composition = #intersecton:) ifTrue: [#union:] ifFalse: [#intersection:]]);
		selectIfMatch: self selectIfMatch not;
		context: self context;
		precedence: self precedence;
		override: self override;
		selectorsMessage: selectorsMessage;  
		restrictToPackages: packageRestriction;  
		yourself. ! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 23:00'!
override
	^overrideRules! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/31/2011 17:35'!
override: aBoolean
	overrideRules := aBoolean.! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 23:03'!
overridePrecedence: anArray 
	overrideRules := true.
	precedence := anArray! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 5/1/2011 16:46'!
packageRestrictionIncludes: aClass
	packageRestriction isEmpty
		ifTrue: [ ^ true ]
		ifFalse: [ 
			packageRestriction
				do: [ :packageName | 
					| package |
					package := PackageOrganizer default packageNamed: packageName ifAbsent: nil.
					package
						ifNotNil: [ 
							(package includesClass: aClass)
								ifTrue: [ ^ true ] ] ].
			^ false ]! !

!PhPointcut methodsFor: 'composing' stamp: 'dgg 9/18/2011 17:36'!
pand: aPointcut
	self deprecated: 'Use & intead'! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 5/12/2011 22:54'!
parseReceivers: receiversDefinition
	^ cachedRecParser
		ifNil: [ 
			cachedRecParser := receiversDefinition isPetitParser
				ifTrue: [ receivers ]
				ifFalse: [ 
					receiversDefinition isString
						ifTrue: [ PhPointcut receviersParser parse: receiversDefinition ]
						ifFalse: [ 
							receiversDefinition size = 1
								ifTrue: [ PhPointcut receviersParser parse: (receiversDefinition at: 1) ]
								ifFalse: [ 
									receiversDefinition
										reduce: [ :a :b | 
											| parserA parserB |
											a isPetitParser
												ifTrue: [ parserA := a ]
												ifFalse: [ parserA := PhPointcut receviersParser parse: a ].
											b isPetitParser
												ifTrue: [ parserB := b ]
												ifFalse: [ parserB := PhPointcut receviersParser parse: b ].
											parserA / parserB ] ] ] ] ]! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 5/12/2011 22:52'!
parseSelectors: selectorsDefinition
	^ cachedSelParser
		ifNil: [ 
			cachedSelParser := selectorsDefinition isPetitParser
				ifTrue: [ selectorsDefinition ]
				ifFalse: [ 
					selectorsDefinition isString
						ifTrue: [ PhPointcut selectorsParser parse: selectorsDefinition ]
						ifFalse: [ 
							selectorsDefinition size = 1
								ifTrue: [ PhPointcut selectorsParser parse: (selectorsDefinition at: 1) asString ]
								ifFalse: [ 
									selectorsDefinition
										reduce: [ :a :b | 
											| pa pb |
											a isPetitParser
												ifTrue: [ pa := a ]
												ifFalse: [ pa := PhPointcut selectorsParser parse: a ].
											b isPetitParser
												ifTrue: [ pb := b ]
												ifFalse: [ pb := PhPointcut selectorsParser parse: b ].
											pa / pb ] ] ] ] ]	"| receiversList sel |
	receiversList := self expandReceivers.
	sel := (selectorsString subStrings: ' ') collect: [:e | e asSymbol].
	^ receiversList collect: [:r | sel]"! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
pointcut
	^ pointcut! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
pointcut: anObject
	pointcut := anObject! !

!PhPointcut methodsFor: 'private' stamp: 'johanfabry 10/8/2011 11:40'!
pointcutsThatDontMatchOf: aClassNDescs receiversParser: receiversParser selectorsParser: selectorsParser
	| aCollection aClass|
	aClass := aClassNDescs key.
	aCollection := OrderedCollection new.
	(receiversParser matches: (aClassNDescs value at: 1)) not
		ifTrue: [ (selectorsMessage value: aClass) do: [ :sel | aCollection add: (Array with: aClass with: sel) ] ]
		ifFalse: [ 
			(selectorsMessage value: aClass)
				do: [ :sel | 
					(selectorsParser matches: sel asString) not
						ifTrue: [ aCollection add: (Array with: aClass with: sel) ] ].
			(selectorsMessage = #localSelectors)
				ifTrue: [
					(aClass allSelectors difference: (aClass localSelectors)) do: [:each | aCollection add: (Array with: aClass with: each)] ] ].
	(receiversParser matches: (aClassNDescs value at: 2)) not
		ifTrue: [ (selectorsMessage value: aClass class) do: [ :sel | aCollection add: (Array with: aClass class with: sel) ] ]
		ifFalse: [ 
			(selectorsMessage value: aClass class)
				do: [ :sel | 
					(selectorsParser matches: sel asString) not
						ifTrue: [ aCollection add: (Array with: aClass class with: sel) ] ].
			(selectorsMessage = #localSelectors)
				ifTrue: [
					(aClass class allSelectors difference: (aClass class localSelectors)) do: [:each | aCollection add: (Array with: aClass class with: each)] ] ].
	^ aCollection! !

!PhPointcut methodsFor: 'private' stamp: 'johanfabry 10/8/2011 11:40'!
pointcutsThatMatchOf: aClassNDescs receiversParser: receiversParser selectorsParser: selectorsParser
	| aCollection aClass|
	aCollection := OrderedCollection new.
	aClass := aClassNDescs key.
	(receiversParser matches: (aClassNDescs value at: 1))
		ifTrue: [ 
			(selectorsMessage value: aClass)
				do: [ :sel | 
					(selectorsParser matches: sel asString)
						ifTrue: [ aCollection add: (Array with: aClass with: sel) ] ] ].
	(receiversParser matches: (aClassNDescs value at: 2))
		ifTrue: [ 
			(selectorsMessage value: aClass class)
				do: [ :sel | 
					(selectorsParser matches: sel asString)
						ifTrue: [ aCollection add: (Array with: aClass class with: sel) ] ] ].
	^ aCollection! !

!PhPointcut methodsFor: 'composing' stamp: 'dgg 9/18/2011 17:36'!
por: aPointcut
	self deprecated: 'Use | instead'! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 22:45'!
precedence
	^precedence ifNil: [precedence := #()]! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 00:38'!
precedence: anArray
	overrideRules := false.
	precedence := anArray! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/18/2011 19:38'!
receivers
	^receivers ifNil: [#any asParser star not]! !

!PhPointcut methodsFor: 'accessing' stamp: 'dgg 5/12/2011 22:48'!
receivers: aParserOrString
	cachedRecParser := nil.
	receivers := aParserOrString! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/20/2011 23:35'!
restrictToPackages: aPackageNameArray
	packageRestriction := aPackageNameArray! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/18/2011 22:37'!
selectIfMatch
	^selectIfMatch! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/18/2011 22:37'!
selectIfMatch: aBoolean
	selectIfMatch := aBoolean! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/18/2011 19:38'!
selectors
	^selectors ifNil: [#any asParser star not]! !

!PhPointcut methodsFor: 'accessing' stamp: 'johanfabry 6/10/2011 10:09'!
selectors: aParserOrString
	self setLocal: false.
	cachedSelParser := nil.
	aParserOrString = #()
		ifTrue: [selectors := #any asParser]
		ifFalse: [selectors := aParserOrString]
! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 5/6/2011 01:46'!
selectorsMessage
	^ selectorsMessage! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 5/6/2011 01:46'!
selectorsMessage: aSelectorsMessage
	selectorsMessage :=  aSelectorsMessage! !

!PhPointcut methodsFor: 'private' stamp: 'dgg 5/6/2011 01:42'!
setLocal: aBoolean
	aBoolean 
		ifTrue: [selectorsMessage := #localSelectors]  
		ifFalse: [selectorsMessage := #allSelectors] ! !

!PhPointcut methodsFor: 'composing' stamp: 'dgg 9/18/2011 17:35'!
| aPointcut
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: aPointcut;
		composition: #union:;
		selectIfMatch: self selectIfMatch;
		context: (self mergeContext: aPointcut);
		precedence: self precedence;
		override: self override;
		selectorsMessage: selectorsMessage;
		restrictToPackages: packageRestriction;  
		yourself.  ! !

Object subclass: #PhPrecedenceRulesProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPrecedenceRulesProcessor commentStamp: 'DanielGaldames 4/14/2011 01:55' prior: 0!
This class is reponsable to process the precedence rules and order the advices action on a pointcut.!

!PhPrecedenceRulesProcessor methodsFor: 'graph generation' stamp: 'DanielGaldames 3/25/2011 13:56'!
getGraphFrom: aNodeCollection
	| graph |
	graph := AspectGraph new.
	aNodeCollection reduce: [:parents :children |
		graph addAll: parents.
		graph addAll: children.
		parents do: [:node |
			children do: [:child |
				(graph nodeSet like: node) addNode: (graph nodeSet like: child)]].
		children.].
	^graph.! !

!PhPrecedenceRulesProcessor methodsFor: 'aspect sorting' stamp: 'dgg 6/27/2011 18:17'!
getSortedAspectsWith: aRulesSet
	| graphs graph |
	(aRulesSet isEmpty) ifTrue: [^#()].
	graphs := OrderedCollection new.
	aRulesSet collect: [:rulesArray |
		| nodeCollection |
		nodeCollection := OrderedCollection new.
		rulesArray do: [:rule | nodeCollection add: (PhPrecedenceRulesParser new parse: rule)].
		"lipieza por relga *"
		rulesArray withIndexDo: [:elem :index |
			(elem = '*') ifTrue: [
				nodeCollection withIndexDo: [:col :idx |
					((rulesArray at: idx) = '*') not ifTrue: [
						nodeCollection at: index put: ((nodeCollection at: index) difference: col)]]]].
		graphs add: nodeCollection].
	graph := OrderedCollection new.
	graphs do: [:each |
		| g |
		g := self getGraphFrom: each.
		graph add: g].
	graph := graph reduce: [:a :b | a merge: b].
	(graph existsCycle) ifTrue: [self error: 'Conflict detected in rules set'].
	"graph setPrecedence.
	^ (graph nodeSet asArray sort: [:a :b | a precedence < b precedence]) collect: [:each | each aspect]."
	^ graph getTopologicalSort collect: [:node | node aspect]! !
PhAspectWeaver initialize!
